OpenCL C++ Bindings: cl::SVMAllocator< T, SVMTrait > Class Template Reference

OpenCL C++ Bindings

Classes | Public Types | Public Member Functions | List of all members
cl::SVMAllocator< T, SVMTrait > Class Template Reference

## Classes
struct | rebind

## Public Types
typedef T | value_type
typedef value_type * | pointer
typedef const value_type * | const_pointer
typedef value_type & | reference
typedef const value_type & | const_reference
typedef std::size_t | size_type
typedef std::ptrdiff_t | difference_type

## Public Member Functions
| SVMAllocator (cl::Context context)
| SVMAllocator (const SVMAllocator &other)
template<typename U >
| SVMAllocator (const SVMAllocator< U, SVMTrait > &other)
pointer | address (reference r) CL_HPP_NOEXCEPT_
const_pointer | address (const_reference r) CL_HPP_NOEXCEPT_
pointer | allocate (size_type size, typename cl::SVMAllocator< void, SVMTrait >::const_pointer=0)
void | deallocate (pointer p, size_type)
size_type | max_size () const CL_HPP_NOEXCEPT_
template<class U , class... Args>
void | construct (U *p, Args &&... args)
template<class U >
void | destroy (U *p)
bool | operator== (SVMAllocator const &rhs)
bool | operator!= (SVMAllocator const &a)

## Detailed Description

### template<typename T, class SVMTrait>
class cl::SVMAllocator< T, SVMTrait >

STL-like allocator class for managing SVM objects provided for convenience.

Note that while this behaves like an allocator for the purposes of constructing vectors and similar objects, care must be taken when using with smart pointers. The allocator should not be used to construct a unique_ptr if we are using coarse-grained SVM mode because the coarse-grained management behaviour would behave incorrectly with respect to reference counting.

Instead the allocator embeds a Deleter which may be used with unique_ptr and is used with the allocate_shared and allocate_ptr supplied operations.

Definition at line 3553 of file cl2.hpp.

## Member Function Documentation

## ◆ allocate()

template<typename T , class SVMTrait >

pointer cl::SVMAllocator< T, SVMTrait >::allocate | ( | size_type | size,
|  | typename cl::SVMAllocator< void, SVMTrait >::const_pointer | = `0`
| ) |  |
| inline

Allocate an SVM pointer.

If the allocator is coarse-grained, this will take ownership to allow containers to correctly construct data in place.

Definition at line 3617 of file cl2.hpp.

## ◆ max_size()

template<typename T , class SVMTrait >

size_type cl::SVMAllocator< T, SVMTrait >::max_size | ( |  | ) | const
| inline

Return the maximum possible allocation size. This is the minimum of the maximum sizes of all devices in the context.

Definition at line 3659 of file cl2.hpp.

## ◆ operator==()

template<typename T , class SVMTrait >

bool cl::SVMAllocator< T, SVMTrait >::operator== | ( | SVMAllocator< T, SVMTrait > const & | rhs | ) |
| inline

Returns true if the contexts match.

Definition at line 3687 of file cl2.hpp.

The documentation for this class was generated from the following file:

- cl2.hpp